# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

#
# Snappy Ecosystem Tests
# Copyright (C) 2017 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

"""Entry point to run snappy ecosystem tests"""

import re
import sys
import pytest

FILTER_ARGUMENTS = '--proxy'


def _filter_arguments():
    """Remove from command line arguments all the ones that are in
     FILTER_ARGUMENTS list."""
    filtered_args = sys.argv[1:]
    for i, arg in enumerate(sys.argv[1:]):
        if arg in FILTER_ARGUMENTS:
            filtered_args.pop(i + 1)
            filtered_args.pop(i)
    return filtered_args


def _parse_arguments():
    """Parse and filter command line arguments to makethem pytest compatible"""
    sys.argv[0] = re.sub(r'(-script\.pyw?|\.exe)?$', '', sys.argv[0])
    return _filter_arguments()

if __name__ == '__main__':
    sys.exit(pytest.main(args=_parse_arguments() + ['-p', 'no:cacheprovider']))
